.nolist
    include     \masm32\include\masm32rt.inc    ; defaults to .386
    .586
    include     timers.asm      ; requires a pentium

    LOOPCOUNT equ 100000;0

    PROCS TEXTEQU <szLength,Ratch,Jens_fast_strlen,roticvSSE,lszLenSSE,Jens_mmx2>
    LastString= 999
    SIZES TEXTEQU <0,1,2,3,5,8,13,22,39,55,89,144,239,LastString>

    HPROC TEXTEQU <szLen>        ; Function to calculate length for header
.listall
    %FOR proc,<PROCS>
        proc proto :DWORD
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 9
    COLWIDTH  equ 5

.data

    %FOR extra,<0,1,2,3>
        %FOR len,<SIZES>
            align 16
            db extra dup (0)
            str&extra&b&len& db len dup (254),0
            db 8 dup (255),0    ; possible next string
        ENDM
    ENDM

.code
align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

align 16
start:
    ; make a real test string with all ascii characters-
    %FOR extra,<0,1,2,3>
        mov edx,offset str&extra&bLastString
        mov al,1
        mov ecx,LastString
@@:     
        mov [edx],al
        inc al
        .if al==0
            inc al
        .endif
        inc edx
        dec ecx
        jnz @b
    endm        
         
    print chr$("Test routines for correctness:",13,10)
    %FOR extra,<0,1,2,3>
        print chr$("&extra& byte misalignment",13,10)
        %FOR proc,<PROCS>
            print fld$(chr$("&proc&"),HDRWIDTH)
            %FOR len,<SIZES>
                invoke proc,ADDR str&extra&b&len&
                ;invoke proc,ADDR str2b&len&
                print fld$(sstr$(eax),COLWIDTH,1)
            ENDM
            print chr$(13,10)
        ENDM
    ENDM

    print chr$(13,10)
    print fld$(chr$("Proc/Bytes"),HDRWIDTH)

    %FOR len,<SIZES>
        invoke HPROC, ADDR str0b&len&
        print fld$(sstr$(eax),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES>
        invoke StrLen,ADDR str0b&len&
        print fld$(" ====",COLWIDTH)
    ENDM
    print chr$(13,10)

    %FOR extra,<0,1,2,3>
        print chr$(13,10)
        print chr$("&extra& byte misalignment",13,10)
       %FOR proc,<PROCS>
            print fld$(chr$("&proc&"),HDRWIDTH)
            %FOR len,<SIZES>
                counter_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
                invoke proc,ADDR str&extra&b&len&
                counter_end
                mov ebx,eax
                print fld$(sstr$(ebx),COLWIDTH,1)
            ENDM
        print chr$(13,10)
        ENDM
    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; --------------------- Routines under test ---------------------------------------------

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

szLength proc src:DWORD
            mov     eax, [esp + 4]          ; point eax to start of string
            test    eax, 3
            jnz     fixalign                ; jmp to fix misalignment
            align   4
zscan:      mov     edx, [eax]              ; load next four bytes
resume:     lea     ecx, [edx - 1010101h]
            not     edx                     ; on each byte in edx: (byte-1) & ~byte & 80h
            and     edx, 80808080h
            and     edx, ecx
            jnz     found                   ; branch if found

            mov     edx, [eax + 4]          ; load next four bytes
            add     eax, 8                  ; advance ptr (twice)
            lea     ecx, [edx - 1010101h]
            not     edx                     ; on each byte in edx: (byte-1) & ~byte & 80h
            and     edx, 80808080h
            and     edx, ecx
            jz      zscan                   ; repeat while no zeros found
            sub     eax, 4                  ; back off to last dword
            align   4
found:      sub     eax, [esp + 4]          ; subtract the base address
            test    edx, 8080h              ; test first two bytes
            jz      upper2                  ; jmp if not found in the lower 2 bytes
            shr     edx, 8                  ; set carry from bit7 of 1st byte
            sbb     eax, -1                 ; return eax = eax + (1-carry)
            ret     4
upper2:     shl     edx, 9                  ; set carry from bit7 of 3rd byte
            sbb     eax, -3                 ; return eax = (eax+2) + (1-carry)
            ret     1*4

        align   4
fixalign:   mov     ecx, eax
            and     eax,not 3           ; eax points to aligned addr            
            and     ecx, 3                  ; ecx = bytes to skip
            mov     edx, 1
            shl     ecx, 3                  ; ecx = bits to skip
            shl     edx, cl                 ; put cl 1's into edx from the bottom up
        mov     ecx, [eax]              ; preload 1st word into ecx
            sub     edx, 1
            or      edx, ecx                ; combine with first four bytes
            jmp     resume                  ; start up in the aligned search
szLength endp


align 16

Ratch proc junk:dword      ; from Ratch           ;it all begins here
    MOV EAX,[ESP+DWORD]       ;address of string

    .REPEAT                   ;searching string ....
        MOV EDX,[EAX]           ;next 4 byte gulp (DWORD)
        ADD EAX,DWORD           ;EAX=character pointer
        LEA ECX,[EDX-01010101H] ;propagate if byte is zero
        NOT EDX                 ;set up test pattern
        AND EDX,ECX             ;leftmost bit of zero byte should now be set
        AND EDX,080808080H      ;sieve out zero bytes
    .UNTIL !ZERO?             ;check the next DWORD

                           ;we now know the current DWORD contains a zero byte
    SUB EAX,DWORD+BYTE        ;compensate for entry additions into loops

    .REPEAT                   ;searching current DWORD ...
        INC EAX                 ;increase word count if no carry from shift
        ROR EDX,8               ;bring leftmost bit of each byte into carry flag
    .UNTIL CARRY?             ;if carry flag set, byte is zero

    SUB EAX,[ESP+DWORD]       ;subtract beginning of string to get length

    RET DWORD                 ;all done, and string length in EAX

Ratch endp

align 16

Jens_fast_strlen PROC item:DWORD

    mov ecx, [esp+4] 
    
@@:
    mov eax, dword ptr [ecx]
    add ecx, 4
    
    lea edx, [eax - 01010101h]
    xor eax, edx
    and eax, 80808080h
    jz @B
    and eax, edx
    jz @B
    
    bsf edx, eax
    
    sub edx, 4
    shr edx, 3
    
    lea eax, [ecx + edx - 4]
    sub eax, [esp+4] 
    
    RET 4

Jens_fast_strlen ENDP

;--------------   routines using mmx/sse ---------------------------------------------------------------
.xmm

align 16
roticvSSE proc lpstring:dword
        mov     eax, [esp+4]
        cmp     byte ptr[eax], 0
        mov     ecx, eax
        jz      done
        and     ecx, 0FFFFFFF8h
        add     ecx, 8
        sub     ecx, eax
        cmp     ecx, 8
        jz      aligned
    @@:
        add     eax, 1              ;Simple byte scanner for alignment
        cmp     byte ptr[eax],0
        jz      done
        sub     ecx, 1
        jnz     @B
    aligned:
        pxor    mm1, mm1
        align 16
    @@:
        movq    mm0, [eax]
        pcmpeqb mm0,mm1
        add     eax, 8
        pmovmskb ecx,mm0
        test    ecx, ecx
        jz      @B
        bsf     ecx, ecx
        emms
        lea     eax, [eax+ecx-8]
    done:
        sub     eax, [esp+4]
        retn 4
roticvSSE endp

align 16

lszLenSSE proc pString:DWORD    ; Donkey's SSE strlen for long strings
        mov eax,[esp+4]
        nop
        nop                     ; fill in stack frame+mov to 8 bytes

        pxor mm0,mm0
        nop                     ; fill pxor to 4 bytes
        pxor mm1,mm1
        nop                     ; fill pxor to 4 bytes

    @@:                         ; this is aligned to 16 bytes
        movq mm0,[eax]
        pcmpeqb mm0,mm1
        add eax,8
        pmovmskb ecx,mm0
        or ecx,ecx
        jz @B

        sub eax,[esp+4]

        bsf ecx,ecx
        sub eax,8
        add eax,ecx

        emms

        ret 1*4

lszLenSSE endp
    
align 16
Jens_mmx2 proc lpString:DWORD   ; modified to assume mmx available

    CheckForMMx = 0 ; assume mmx available

    if CheckForMMx NE 0
        mov eax, 1 ; request CPU feature flags  ; how to check for mmx if desired
        cpuid ; CPUID instruction
    endif

;- Pre-Scan to align the string-start ----
    mov ecx, [esp+4]
    mov eax, ecx
    cmp byte ptr [eax], 0
    je done
    and ecx, 0FFFFFFF8h
    add ecx, 8
    sub ecx, eax
    cmp ecx, 8
    je aligned
@@:
    inc eax
    cmp byte ptr [eax], 0
    je done
    dec ecx
    jnz @B

aligned:
    mov ecx, eax

    if CheckForMMx ne 0
        test edx, 800000h ; test bit 23 to see if MMX available
        jz no_mmx ; jump if no MMX is available
    endif

    pxor mm0, mm0

@@:
    movq mm1, qword ptr [ecx]
    movq mm2, qword ptr [ecx + 8]
    movq mm3, qword ptr [ecx + 16]
    movq mm4, qword ptr [ecx + 24]
    movq mm5, qword ptr [ecx + 32]
    movq mm6, qword ptr [ecx + 40]
    
    pcmpeqb mm1, mm0
    pcmpeqb mm2, mm0
    pcmpeqb mm3, mm0
    pcmpeqb mm4, mm0
    pcmpeqb mm5, mm0
    pcmpeqb mm6, mm0
    
    por mm1, mm2
    por mm3, mm4
    por mm5, mm6
    por mm1, mm3
    por mm1, mm5
    
    add ecx, 48
    
    packsswb mm1, mm1
    movd eax, mm1
    test eax, eax
    jz @B
    
    sub ecx, 48

    emms ; Empty MMX state

no_mmx:

@@:
    mov eax, dword ptr [ecx]
    add ecx, 4
    
    lea edx, [eax - 01010101h]
    xor eax, edx
    and eax, 80808080h
    and eax, edx
    jz @B

    bsf edx, eax
    
    sub edx, 4
    shr edx, 3
    
    lea eax, [ecx + edx - 4]

done:

    sub eax, [esp+4]
    ret 4

Jens_mmx2 endp


OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start
